require "util"

script.on_event(defines.events, function(event)
	-- on_tick
	if event.name == defines.events.on_tick then
		for playerIndex, player in pairs(game.players) do
			if player.gui.top.decrease == nil then
				player.gui.top.add{name = "decrease", type = "button", caption = "<", style="fentus_button"}
			end
			
			if player.gui.top.decrease1 == nil then
				player.gui.top.add{name = "decrease1", type = "button", caption = "<<", style="fentus_button"}
			end
			
			if player.gui.top.display == nil then
				player.gui.top.add{name = "display", type = "label", caption = "Speed "..tostring(format_num(game.speed,2,"x","")), style="fentus_label"}
			end
	
			if player.gui.top.increase1 == nil then
				player.gui.top.add{name = "increase1", type = "button", caption = ">>", style="fentus_button"}
			end
	
			if player.gui.top.increase == nil then
				player.gui.top.add{name = "increase", type = "button", caption = ">", style="fentus_button"}
			end
		end
	end
	
	-- on_gui_click
	if event.name == defines.events.on_gui_click then
		
		if event.element.name == "decrease" then
			speed(-0.1)
		end
		
		if event.element.name == "decrease1" then
			speed(-1)
		end
		
		if event.element.name == "increase1" then
			speed(1)
		end
		
		if event.element.name == "increase" then
			speed(0.1)
		end
	end
end)

function speed(adjust)
	for playerIndex, player in pairs(game.players) do
		if player.gui.top.decrease then
			game.speed = math.clamp(game.speed + adjust, 0.1, 25)
			player.gui.top.display.caption = "Speed "..tostring(format_num(game.speed,2,"x",""))
			break
		end
	end
end

function format_num(amount, decimal, prefix, neg_prefix)
  local str_amount,  formatted, famount, remain

  decimal = decimal or 2
  neg_prefix = neg_prefix or "-"

  famount = math.abs(round(amount,decimal))
  famount = math.floor(famount)

  remain = round(math.abs(amount) - famount, decimal)

  formatted = comma_value(famount)

  if (decimal > 0) then
    remain = string.sub(tostring(remain),3)
    formatted = formatted .. "." .. remain ..
                string.rep("0", decimal - string.len(remain))
  end

  formatted = (prefix or "") .. formatted 

  if (amount<0) then
    if (neg_prefix=="()") then
      formatted = "("..formatted ..")"
    else
      formatted = neg_prefix .. formatted 
    end
  end

  return formatted
end

function round(val, decimal)
  if (decimal) then
    return math.floor( (val * 10^decimal) + 0.5) / (10^decimal)
  else
    return math.floor(val+0.5)
  end
end

function comma_value(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end

function math.clamp(val, lower, upper)
    if lower > upper then
		lower, upper = upper, lower
	end
	
    return math.max(lower, math.min(upper, val))
end

script.on_event("decrease", function(event) return speed(-0.1) end)
script.on_event("decrease1", function(event) return speed(-1) end)
script.on_event("increase1", function(event) return speed(1) end)
script.on_event("increase", function(event) return speed(0.1) end)